part of empirical;

const STYLE_ID = 'gamestyle';
const CANVAS_ID = 'gamecanvas';
const TITLE_ID = 'gametitle';

const INTERFACE_CLASS = 'popup';
const FULLSCREEN_MODE = true;
const MOBILE_MODE = false;

const MOBILE_WIDTH = 480;
const MOBILE_HEIGHT = 800;

const NORMAL_WIDTH = 680;
const NORMAL_HEIGHT = 480;

final style = new StyleElement();
final canvas = new CanvasElement();
final title = new HeadingElement.h1();
final context = canvas.getContext('2d');

canvasInterface() {
  canvas.id = CANVAS_ID;
  style.id = STYLE_ID;
  title
  ..id = TITLE_ID
  ..text = 'Empirical';
  document.body.children.addAll([style, title, canvas]);
  resizeCanvas();
  int popupWidth = 520; //int popupWidth = (canvas.width * 0.70).toInt(); //60% of the canvas width
  style.appendText('''

* {
  -moz-user-select: none;
  -webkit-user-select: none;
  -user-select: none;
}

body {
  font-family: 'Open Sans', sans-serif;
  line-height: 1.2em;
  margin: 0px;
  overflow: hidden;
}

.$INTERFACE_CLASS {
  top: 75px; 
  display: none;
  position: absolute;
  text-align: center;
  background-color: rgb(247,235,203);
  color: white;
  border: 7px solid rgb(221,212,193);
  margin: 40px;
  box-shadow: 5px 5px 10px 5px rgba(0, 0, 0, 0.5);
  background-color: black;
  width: ${popupWidth}px;
  height: ${canvas.height * 0.6}px;
  left: 50%;
  margin-left: -${popupWidth / 2}px;
}

.$INTERFACE_CLASS h1 {
  font-family: Roboto;
  padding-bottom: 40px;
}

.$INTERFACE_CLASS a {
  float: left;
  padding: 10px 80px 10px 80px;
  border: grey solid 1px;
  background-color: #E0E0E0;
  margin-bottom: 20px;
  width: 10%;
  color: black;
  clear: both;
  margin-left: ${popupWidth * 0.3}px;
}

.$INTERFACE_CLASS a:hover {
  background-color: #D8D8D8;
  color: grey;
  cursor: pointer;
}

#$CANVAS_ID {
  padding-left: 0;
  padding-right: 0;
  margin-left: auto;
  margin-right: auto;
  display: block;
}

#$TITLE_ID {
  text-align: center;
  font-family: Impact;
  letter-spacing: 2px;
  font-size: 36px;
}
''');
}

hideTitleBar() {
  query('#${TITLE_ID}').style.display = 'none';
}

resizeCanvas() {
  if (FULLSCREEN_MODE) {
    hideTitleBar();
    canvas.width = window.innerWidth;
    canvas.height = window.innerHeight;
  } else if (MOBILE_MODE) {
    hideTitleBar();
    canvas.width = MOBILE_WIDTH;
    canvas.height = MOBILE_HEIGHT;
  } else {
    canvas.width = NORMAL_WIDTH;
    canvas.height = NORMAL_HEIGHT;
  }
}